
/************************************************/
/* Use Microsoft C Compiler Version 5 or Quick C to compile and link */
/* to obtain an EXE programme. */
/* $ sign at the end of test sentence to simulate a mistake and */
/* to stop the programme. */
/* You can vary the test sentence to see how the programme works */
/* but if you alter the "Dictionary", you have to */
/* adjust the figures in the jump table  array to fit. */

#include <stdio.h>
#include <conio.h>
unsigned char *dic [] = {
/*8 0 0*/            "","г","","","ʥ","","׫","ױ",
/*3 1 8*/            "ݷ","","",
/*3 2 11*/           "","","",
/*2 3 14*/           "","ʥ",
/*2 4 16 */          "","",

/*2 5 18*/           "","",
/*4 6 20*/           "","","","̷",
/*2 7 24*/           "","",
/*3 8 26*/           "ڡ","ڲ","",
/*  9  */

/*  10 */
/*  11 */
/*  12 */
/*2 13 29*/          "η","η",
/*  14  */

/*  15  */
/*2 16 31*/          "","",
/*3 17 33*/          "","","",
/*2 18 36*/          "","",
/*3 19 39*/          "","","",

/*2 20 41*/          "","",
/*2 21 43*/          "","",
/*2 22 45*/          "","Ĳ",
/*2 23 47*/          "","",
/*2 24 49*/          "١","٣",

/*2 25 51*/          "","",
/*2 26 53*/          "","إ",
/*2 27 55*/          "","",
/*2 28 57*/          "","ʡ",
/*2 29 59*/          "Ψ","μ",

/*2 30 61*/          "","",
/*2 31 63*/          "Ĳ","ķ",
/*2 32 65*/          "","Ĳ",
/*2 33 67*/          "²","µ",
/*3 34 69*/          "å","ò","ʥ",

/*4 35 72*/          "ʲ","ʷ","","β",
/*2 36 76*/          "ʡ","",
/*  37  */
/*6 38  78*/         "ߦ","Ը","ס","ע","ײ","إ",
/*3 39  84*/         "ȷʥ","","ʡ",

/*  40  */
/*2 41  87*/         "ʥ","",
/*2 42  89*/         "","",
/*  43  */
/*  44  */

/*  45  */
/*16 4691*/         "С","","","","","","",
                     "ʡ","","ʥ","â","â","÷","",""
                  };

unsigned char  jmptable [50] = {
     /* each number means the subscript of Dictionary Array */
                    /* 0 */     0, 8,11,14,16,
                               18,20,24,26,-1,
                    /* 10 */   -1,-1,-1,29,-1,
                               -1,31,33,36,39,
                    /* 20 */   41,43,45,47,49,
                               51,53,55,57,59,
                    /* 30 */   61,63,65,67,69,
                               72,76,-1,78,84,
                    /* 40 */   -1,87,89,-1,-1,
                               -1,91,-1,-1,-1};

     /* eg. dic [8] = Kor kai, dic [8+3] = kor kwai */

unsigned char  *sentence  =  "ڡʥืʡʥ$";
/*unsigned char  *sentence = "г⡡Ըݷإס$";*/

main ()
{
     int    i,di1, di2, notfound, returnvalue, exist;
     unsigned char   *beginword;
     unsigned char   *eop;   /* end of pattern to check */
     unsigned char   temp;

     eop = beginword = sentence;
                             /* address of the start of the word to check */
     eop++;                  /* move end of pattern 2 places */
     eop++;                  /* to send at least 2 letters to check */

     do  {
        exist = 0;           /* There is this word in Dictionary */
        notfound = 0;
                             /* use first letter of the word to check */
                             /* to point to array of words kept */
                             /* in dictionary ; di1 points to the */
                             /* beginning, di2 points to the end  */
        di1 = jmptable [beginword [0]-0xa1];
        di2 = jmptable [beginword [0]-0xa1+1];

        while (!notfound)  {
           temp = *eop;      /* limit the string to 2 letters at first */
                             /* to make pattern, thus this byte must be */
                             /* restored to original value later */
           *eop = '\0';
                             /* show the pattern being checked */
           printf ("\r\n %s ",beginword);

           for (i = di1; i < di2; i++)  {
              if ((returnvalue = index (dic [i], beginword)) == 0)  {
                 notfound = 0;
                 exist = 1;
                 break;
              }
              notfound = 1;
           }
           *eop = temp;      /* increase length of pattern */
           eop++;
                             /* until 'exist' flag = 0 */
        }                    /* meaning no such word in dictionary */
        beginword = eop - 2; /* go back 2 bytes for another word */
        printf ("\r\n");
     }  while (exist);       /* go back while still checking all right */
     *--eop = '\0';
     printf ("Mistake is  %s\r\n",(beginword-1));
}

index (s, t)
unsigned char s[],  t[];
{
     int  i, j, k;
     for (i = 0; s [i] != '\0'; i++)  {
         for (j = i, k = 0;
                 t [k] != '\0' && s [j] == t [k]; j++ , k++)
                    ;
         if (t [k] == '\0')
             return (i);
     }
     return (-1);
}
/************************************************/
